<?php

/***********************************************************************

 設定は config.php ファイルをごらんください

************************************************************************/

// ---------------------------------------------------------------------


require_once('config.php');
require_once('./inc/gamesession.php');

function data_decode($data) {
	if (is_array($data)) {
		foreach ($data as $key => $value) {
			$data[$key] = data_decode($value);
		}
	} else {
		$data = mb_convert_encoding($data, STR_ENCODE, 'auto');
		if (get_magic_quotes_gpc())
			$data = stripslashes($data);
		$data = trim(htmlspecialchars($data));
	}
	return $data;
}

ob_start();
header('Cache-Control: no-cache, must-revalidate');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Content-Type: text/html; charset='.STR_ENCODE); 

if ($_SERVER['REQUEST_METHOD'] == 'POST')
	$_POST = data_decode($_POST);

$session = GameSession::load();

$id = $session->isLogin();

if ($id and isset($_POST['cmd']) and $_POST['cmd'] == 'logout') {
	$session->gameLogout($id);
	$id = false;
}

?>
<?php echo '<?xml version="1.0" encoding="'.STR_ENCODE.'"?>' ?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
<head>
<link rel="stylesheet" type="text/css" href="./kenran.css" />
<script type="text/javascript" src="./kenran.js"></script>
<title>絢爛舞踏祭-戦闘ゲーム[<?php echo GAME_NAME ?>]</title>
</head>
<?php
if ($id !== false) {
	$name = $session->getName($id);
	$color = $session->getColor($id);
?>
<body onload="init(<?php echo RELOAD_INTERVAL; ?>, <?php echo LOG_MAX; ?>);">
<div><table border="0" cellspacing="0" align="center"><tbody><tr><th class="header" colspan="6"><?php echo $name; ?></th><td rowspan="6" style="background-color:#000;"><applet width="<?php echo RADAR_SIZE; ?>" height="<?php echo RADAR_SIZE; ?>" code="kenran.Radar" codebase="./" archive="kenran.jar" id="radar"><param name="depth_max" value="<?php echo DEPTH_MAX; ?>"><param name="color" value="<?php echo implode(',', $color); ?>"></applet></td></tr>
<tr><td class="header">耐久力</td><td class="header">機動</td><td class="header">深度</td><td class="header">速度</td><td class="header">機雷数</td><td class="header">魚雷数</td></tr>
<tr><td id="my_durab">--</td><td id="my_m">--</td><td id="my_d">--</td><td id="my_s">--</td><td id="my_mine">--</td><td id="my_torpedo">--</td></tr>
<tr class="header"><td>シールド</td><td colspan="3">状態</td><td colspan="2">残り秒数</td></tr>
<tr><td id="my_shield">--</td><td colspan="3" id="my_state">--</td><td colspan="2" id="my_limit">--</td></tr>
<tr><td colspan="6"><form action="" method="post" id="action_form"><div><input type="hidden" name="cmd" value="logout" id="action_form_cmd"><select id="action_select" style="width:19em;"><option value="1">離脱</option></select> <input type="submit" value="決定" id="action_form_button"></div></form></td></tr>
</tbody></table></div>
<div><table border="0" cellspacing="0"><thead><tr><th colspan="6">行動順表</th><td><button disabled="disabled" id="update_button">更新</button></td></tr><tr><tr><td style="width:10.0em">名前</td><td style="width:4.0em">耐久力</td><td style="width:3.0em">機動</td><td style="width:3.0em">深度</td><td style="width:3.0em">速度</td><td>撃墜数</td><td>行動選択中</td></tr></thead>
<tbody id="list_tbody">
<tr><td>--</td><td>--</td><td>--</td><td>--</td><td>--</td><td>--</td><td>--</td></tr>
</tbody></table></div>
<?php
} else {
	$login_error = null;
	if (isset($_POST['cmd']) and $_POST['cmd'] == 'login') {
		$login_error = $session->login($_POST['name'], $_POST['color']);
		if (!$login_error) {
			unset($session);
			$script = substr($_SERVER['SCRIPT_NAME'], 0, 1) == '/'? $_SERVER['SCRIPT_NAME']: ('/'.$_SERVER['SCRIPT_NAME']);
			header('Location: http://'.$_SERVER['SERVER_NAME'].$script);
		}
	}
?>
<body>
<h1><?php echo GAME_NAME ?></h1>
<div><table border="0" cellspacing="0" id="game_info"><thead><tr><th colspan="4">ゲーム情報</th></thead>
<tbody><tr><th style="width:6.5em">最大参加者数</th><td style="width:6.5em"><?php echo PLAYER_MAX ?></td><th style="width:6.5em">入力制限時間</th><td style="width:6.5em"><?php echo INPUT_TIME_LIMIT ?>秒</td></tr>
<tr><th>耐久力</th><td><?php echo RB_DURABILITY ?></td><th>耐久力の回復</th><td><?php echo (AUTO_REPAIR_TURN <= 0 or AUTO_REPAIR_PT <= 0)? 'なし': (AUTO_REPAIR_TURN.'ターン毎に'.AUTO_REPAIR_PT); ?></td></tr>
<tr><th>機雷所持数</th><td><?php echo MINE_MAX ?></td><th>魚雷所持数</th><td><?php echo TORPEDO_MAX ?></tr>
<tr><th>機雷有効時間</th><td><?php echo MINE_LIFE <= 0? '無限': (MINE_LIFE.'ターン'); ?></td><th>魚雷有効時間</th><td><?php echo TORPEDO_LIFE <= 0? '無限': (TORPEDO_LIFE.'ターン'); ?></td></tr>
<tr><th>機雷数の回復</th><td><?php echo AUTO_ADD_MINE_TURN <= 0? 'なし': (AUTO_ADD_MINE_TURN.'ターン毎'); ?></td><th>魚雷数の回復</th><td><?php echo AUTO_ADD_TORPEDO_TURN <= 0? 'なし': (AUTO_ADD_MINE_TURN.'ターン毎'); ?></td></tr>
</tbody></table></div>
<div><table border="0" cellspacing="0"><thead><tr><th colspan="7">参加者</th></tr><tr><td>色</td><td style="width:10.0em">名前</td><td style="width:4.0em">耐久力</td><td style="width:3.0em">機動</td><td style="width:3.0em">深度</td><td style="width:3.0em">速度</td><td>撃墜数</td></tr></thead>
<tbody>
<?php
	$list = $session->playersList();
	if (count($list)) {
		foreach ($list as $player) {
			echo '<tr><td style="color:rgb('.$player->red.','.$player->green.','.$player->blue.')">■</td><td class="name">'.$player->name.'</td><td>'.$player->rb->durab.'</td><td>'.$player->rb->mobil.'</td><td>'.$player->rb->depth.'</td><td>'.$player->rb->speed.'</td><td>'.$player->score.'</td></tr>';
		}
	} else {
		echo '<tr><td>--</td><td>--</td><td>--</td><td>--</td><td>--</td><td>--</td><td>--</td></tr>';
	}
?>

<tr><td colspan="7" id="login_form_td">
<div>
<?php echo $login_error != false? ('<div class="error">'.$login_error.'</div>'): ''; ?>

<script type="text/javascript">
<!--
	loginForm('<?php echo $_SERVER['SCRIPT_NAME']; ?>', <?php echo COLOR_RANGE_MIN; ?>, <?php echo COLOR_RANGE_MAX; ?>);
// -->
</script>
<noscript><div class="message">ゲームへの参加には<a href="http://www.java.com/">Java</a>とJavaScriptを有効にする必要があります</div></noscript>
</div>
</td></tr>
</tbody></table></div>
<?php
}
$log = $session->gameLog();
if ($log !== null) {
?>
<div><table border="0" cellspacing="0" id="game_log"><thead><tr><th>ゲームログ</th></tr></thead>
<tbody><tr><td id="log_td">
<div id="log_div">
<?php
	if (count($log) > 0) {
		foreach ($log as $msg) {
			//echo '<div>'.date('H:i:s', $msg[0]).' '.$msg[1].'</div>';
			echo '<div>'.$msg[1].'</div>';
		}
	}
?>
</div>
</td></tr></tbody></table></div>
<?php
}
$ranking = $session->scoreRanking();
if ($ranking !== null) {
?>
<div><table border="0" cellspacing="0" style="width:350px;"><thead><tr><th colspan="2">撃墜数ランキング</th></tr><tr><td width="50">撃墜数</td><td>プレイヤー名</td></tr></thead>
<tbody id="ranking_tbody">
<?php
	if (count($ranking) > 0) {
		foreach ($ranking as $kill => $names) {
			foreach ($names as $name)
				echo '<tr><td>'.$kill.'</td><td>'.$name.'</td></tr>'."\n";
		}
	} else {
		echo '<tr><td>--</td><td>--</td></tr>'."\n";
	}
?>
</tbody></table></div>
<?php
}
unset($session);
?>
</body>
</html>